diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
index 4155a8f1f..7ecdf85a9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
@@ -4,9 +4,10 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 
 public class BlockModelSeat<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelSeat(Block<T> block) {
@@ -14,24 +15,25 @@ public class BlockModelSeat<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        AABBd bounds = new AABBd(this.block.getBoundsFromState(worldSource, tilePos));
 
         renderBlocks.setRenderSide(Side.BOTTOM, false); // Set bottom face to not render
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // Render seat
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos); // Render seat
 
         // Set only the bottom face to render
         renderBlocks.renderBitMask = 0b111111;
         renderBlocks.setRenderSide(Side.BOTTOM, true);
         bounds.minY += 0.1875D; // Shift the bottom face up
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // Render Seat
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos); // Render Seat
 
         // Reset block values
         renderBlocks.renderBitMask = 0;
         return true;
     }
+
     @Override
-    public boolean shouldItemRender3d(){
+    public boolean shouldItemRender3d() {
         return false;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
index e8a6e1f00..78a09a529 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
@@ -5,33 +5,35 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelSlab<T extends BlockLogicSlab> extends BlockModelStandard<T> {
     protected BlockModelStandard<T> parentModel;
-    public BlockModelSlab(Block<T> block){
+
+    public BlockModelSlab(Block<T> block) {
         super(block);
-        parentModel = (BlockModelStandard<T>)BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
-        blockTextures.copy(parentModel.blockTextures);
-        overbrightTextures.copy(parentModel.overbrightTextures);
-        retroBlockTextures.copy(parentModel.retroBlockTextures);
-        retroOverbrightTextures.copy(parentModel.retroOverbrightTextures);
+        this.parentModel = (BlockModelStandard<T>) BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
+        this.blockTextures.copy(this.parentModel.blockTextures);
+        this.overbrightTextures.copy(this.parentModel.overbrightTextures);
+        this.retroBlockTextures.copy(this.parentModel.retroBlockTextures);
+        this.retroOverbrightTextures.copy(this.parentModel.retroOverbrightTextures);
         withCustomItemBounds(0, 0, 0, 1, 0.5d, 1);
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        return parentModel.getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        return this.parentModel.getBlockTextureFromSideAndMetadata(side, this.block.getLogic().modelBlockMetadata);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
-    {
-        return parentModel.getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return this.parentModel.getBlockTextureFromSideAndMetadata(side, this.block.getLogic().modelBlockMetadata);
     }
 
     @Override
     public int renderLayer() {
-        return parentModel.renderLayer();
+        return this.parentModel.renderLayer();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
index b756ab8ae..031d08560 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
@@ -7,25 +7,26 @@ import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelSlabMarble<T extends BlockLogicSlab> extends BlockModelSlab<T> {
     protected IconCoordinate slabSide = TextureRegistry.getTexture("minecraft:block/carved_marble");
+
     public BlockModelSlabMarble(Block<T> block) {
         super(block);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
-    {
-        return getBlockTextureFromSideAndMetadata(side, blockAccess.getBlockMetadata(x, y, z));
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return getBlockTextureFromSideAndMetadata(side, source.getBlockData(tilePos));
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        if(data != 1 && (side.getAxis() != Axis.Y))
-        {
-            return slabSide;
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (data != 1 && (side.getAxis() != Axis.Y)) {
+            return this.slabSide;
         }
         return super.getBlockTextureFromSideAndMetadata(side, data);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
index 7fb6e7ce3..4a80401dd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
@@ -5,6 +5,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelSlabPainted<T extends BlockLogicSlab> extends BlockModelSlab<T> {
@@ -13,14 +15,13 @@ public class BlockModelSlabPainted<T extends BlockLogicSlab> extends BlockModelS
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int meta) {
         meta = meta >> 4;
         return BlockModelPlanksPainted.texCoords[meta & 0x0F];
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
-    {
-        return getBlockTextureFromSideAndMetadata(side, blockAccess.getBlockMetadata(x, y, z));
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return getBlockTextureFromSideAndMetadata(side, source.getBlockData(tilePos));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
index 9dd740c5a..060ab63f3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
@@ -7,10 +7,10 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicSpikes;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.useless.dragonfly.DisplayPos;
+import org.joml.primitives.AABBd;
 
 public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelSpikes(Block<T> block) {
@@ -18,28 +18,32 @@ public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int metaData = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int metaData = worldSource.getBlockData(tilePos);
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.EAST, metaData);
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        if (renderBlocks.overrideBlockTexture != null) {
             texture = renderBlocks.overrideBlockTexture;
         }
 
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), tilePos);
 
-        if(BlockLogicSpikes.isSpikesUp(metaData)) {
+        if (BlockLogicSpikes.isSpikesUp(metaData)) {
             float brightness = 1.0f;
-            if(LightmapHelper.isLightmapEnabled()) {
-            	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-            }else {
-            	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+            if (LightmapHelper.isLightmapEnabled()) {
+                tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+            } else {
+                brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
             }
             tessellator.setColorOpaque_F(brightness, brightness, brightness);
             double uMin = texture.getIconUMin();
             double uMax = texture.getIconUMax();
             double vMin = texture.getIconVMin();
             double vMax = texture.getIconVMax();
+
+            final int x = tilePos.x();
+            final int y = tilePos.y();
+            final int z = tilePos.z();
+
             double d7 = (x + 0.5D) - 0.25D;
             double d8 = x + 0.5D + 0.25D;
             double d9 = (z + 0.5D) - 0.5D;
@@ -105,6 +109,7 @@ public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T
         }
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index 0503af27e..4d04daa49 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -6,25 +6,28 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicStairs;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStandard<T> {
     protected static final DisplayPos STAIRS_GUI = new DisplayPos(0, 0, 0, 30, 135, 0, 0.625f, 0.625f, 0.625f);
     protected static final DisplayPos STAIRS_HEAD = new DisplayPos(0, 0, 0, 0, -90, 0, 1f, 1f, 1f);
-    protected static final DisplayPos STAIRS_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 2.5f/16f, 0, 75, -135, 0, 0.375f, 0.375f, 0.375f);
+    protected static final DisplayPos STAIRS_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 2.5f / 16f, 0, 75, -135, 0, 0.375f, 0.375f, 0.375f);
     protected BlockModelStandard<T> parentModel;
+
     public BlockModelStairs(Block<T> block) {
         super(block);
-        parentModel = (BlockModelStandard<T>)BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
-        blockTextures.copy(parentModel.blockTextures);
-        overbrightTextures.copy(parentModel.overbrightTextures);
-        retroBlockTextures.copy(parentModel.retroBlockTextures);
-        retroOverbrightTextures.copy(parentModel.retroOverbrightTextures);
+        this.parentModel = (BlockModelStandard<T>) BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
+        this.blockTextures.copy(this.parentModel.blockTextures);
+        this.overbrightTextures.copy(this.parentModel.overbrightTextures);
+        this.retroBlockTextures.copy(this.parentModel.retroBlockTextures);
+        this.retroOverbrightTextures.copy(this.parentModel.retroOverbrightTextures);
 
         setDisplayPos(DisplayPos.GUI, STAIRS_GUI);
         setDisplayPos(DisplayPos.HEAD, STAIRS_HEAD);
@@ -32,62 +35,54 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int meta = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int meta = worldSource.getBlockData(tilePos);
         int hRotation = meta & 0b0011;
         int vRotation = meta & 0b1000;
 
         float stepYOffset = vRotation > 0 ? 0.5f : 0.0f;
 
-        AABB bounds = AABB.fromPool(0, 0, 0, 1, 1, 1);
-
-        if(hRotation == 0)
-        {
-            bounds.set(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        } else
-        if(hRotation == 1)
-        {
-            bounds.set(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        } else
-        if(hRotation == 2)
-        {
-            bounds.set(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        AABBd bounds = new AABBd(0, 0, 0, 1, 1, 1);
+
+        if (hRotation == 0) {
+            bounds.setMin(0.0F, 0.0F + stepYOffset, 0.0F).setMax(0.5F, 0.5F + stepYOffset, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.5F, 0.0F, 0.0F).setMax(1.0F, 1.0F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        } else if (hRotation == 1) {
+            bounds.setMin(0.0F, 0.0F, 0.0F).setMax(0.5F, 1.0F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.5F, 0.0F + stepYOffset, 0.0F).setMax(1.0F, 0.5F + stepYOffset, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        } else if (hRotation == 2) {
+            bounds.setMin(0.0F, 0.0F + stepYOffset, 0.0F).setMax(1.0F, 0.5F + stepYOffset, 0.5F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.0F, 0.0F, 0.5F).setMax(1.0F, 1.0F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         } else {
-            bounds.set(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+            bounds.setMin(0.0F, 0.0F, 0.0F).setMax(1.0F, 1.0F, 0.5F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.0F, 0.0F + stepYOffset, 0.5F).setMax(1.0F, 0.5F + stepYOffset, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
         return true;
     }
 
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if(renderBlocks.useInventoryTint)
-        {
-            int j = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
-            float f1 = (float)(j >> 16 & 0xff) / 255F;
-            float f3 = (float)(j >> 8 & 0xff) / 255F;
-            float f5 = (float)(j & 0xff) / 255F;
+        if (renderBlocks.useInventoryTint) {
+            int j = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
+            float f1 = (float) (j >> 16 & 0xff) / 255F;
+            float f3 = (float) (j >> 8 & 0xff) / 255F;
+            float f5 = (float) (j & 0xff) / 255F;
             GL11.glColor4f(f1 * brightness, f3 * brightness, f5 * brightness, alpha);
         }
-        for(int l = 0; l < 2; l++)
-        {
-            AABB bounds;
-            if(l == 0)
-            {
-                bounds = AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
+        for (int l = 0; l < 2; l++) {
+            AABBdc bounds;
+            if (l == 0) {
+                bounds = new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
             } else {
-                bounds = AABB.fromPool(0.5F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
+                bounds = new AABBd(0.5F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
             }
             GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
             tessellator.startDrawingQuads();
@@ -123,20 +118,19 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
             GL11.glTranslatef(0.5F, 0.5F, 0.5F);
         }
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        return parentModel.getBlockTextureFromSideAndMetadata(side, data);
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        return this.parentModel.getBlockTextureFromSideAndMetadata(side, data);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
-    {
-        return parentModel.getBlockTexture(blockAccess, x, y, z, side);
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return this.parentModel.getBlockTexture(source, tilePos, side);
     }
 
     @Override
     public int renderLayer() {
-        return parentModel.renderLayer();
+        return this.parentModel.renderLayer();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
index 3aa0e7be2..5127fb1a2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
@@ -5,6 +5,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicStairs;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelStairsPainted<T extends BlockLogicStairs> extends BlockModelStairs<T> {
@@ -13,14 +15,13 @@ public class BlockModelStairsPainted<T extends BlockLogicStairs> extends BlockMo
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int meta) {
         meta = meta >> 4;
         return BlockModelPlanksPainted.texCoords[meta & 0x0F];
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
-    {
-        return getBlockTextureFromSideAndMetadata(side, blockAccess.getBlockMetadata(x, y, z));
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        return getBlockTextureFromSideAndMetadata(side, source.getBlockData(tilePos));
     }
 }
